#include "hub75.h"

long int bitplane[4][32][32];
int yline=0,line=0,pixel=0,part=0;
/*
void filldata(char data1[],char B2, char G2, char R2,char B1, char G1, char R1){
	data1[3]=(((B2<<4)&BIT8)|((G2<<3)&BIT7)|((R2<<2)&BIT6)|((B1<<2)&BIT5)|((G1)&BIT4)|((R1>>1)&BIT3))&(0xFC);
	data1[2]=(((B2<<1)&BIT8)|((G2<<1)&BIT7)|((R2<<1)&BIT6)|((B1<<1)&BIT5)|((G1<<1)&BIT4)|((R1<<1)&BIT3))&(0xFC);
	data1[1]=(((B2<<1)&BIT8)|((G2<<1)&BIT7)|((R2<<1)&BIT6)|((B1<<1)&BIT5)|((G1<<1)&BIT4)|((R1<<1)&BIT3))&(0xFC);
	data1[0]=(((B2<<1)&BIT8)|((G2<<1)&BIT7)|((R2<<1)&BIT6)|((B1<<1)&BIT5)|((G1<<1)&BIT4)|((R1<<1)&BIT3))&(0xFC);
}
void	LATset(){
	FIO0SET = 0x4000;
}

void	LATclr(){
	FIO0CLR = 0x4000;
}
void	OEset(){
	FIO0SET = 0x0200;
}
void	OEclr(){
	FIO0CLR = 0x0200;
}
*/


__irq void timer0ISR(void){
  long int readVal;
	readVal = T0IR; // Read current IR value 
	T0IR = readVal; // Write back to IR to clear Interrupt Flag
	
	if(pixel==32){
		if(part<3)
			part++;
		else
			part=0;
 //latch(line);///////////////////////
		FIO1SET = 0x00040000;   //oe 1
		FIO1SET = 0x00020000;   //latch 1
		FIO1CLR = 0x00080000;   //c
		FIO0CLR = 0x32000000;   //CBA__D
		if(line==1)
		{
			FIO0SET = 0x10000000;   //CBA__D
		}
		if(line==2)
		{
			FIO0SET = 0x20000000;   //CBA__D
		}
		if(line==3){
			FIO0SET = 0x30000000;   //line 3
		}	
		if(line==4){
			FIO1SET = 0x00080000;   //c
		}	
		if(line==5){
			FIO1SET = 0x00080000;   //c
			FIO0SET = 0x10000000;   //line 3
		}	
		if(line==6){
			FIO1SET = 0x00080000;   //c
			FIO0SET = 0x20000000;   //line 3
		}	
		if(line==7){
			FIO1SET = 0x00080000;   //c
			FIO0SET = 0x30000000;   //line 3
		}
		if(line==8){
			FIO0SET = 0x02000000;   //line 3
			FIO1CLR = 0x00080000;   //c
			FIO0CLR = 0x30000000;   //line 3
		}
		if(line==9)
		{
			FIO0SET = 0x02000000;   //line 3
			FIO0SET = 0x10000000;   //CBA__D
		}
		if(line==10)
		{
			FIO0SET = 0x02000000;   //line 3
			FIO0SET = 0x20000000;   //CBA__D
		}
		if(line==11){
			FIO0SET = 0x02000000;   //line 3
			FIO0SET = 0x30000000;   //line 3
		}	
		if(line==12){
			FIO0SET = 0x02000000;   //line 3
			FIO1SET = 0x00080000;   //c
		}	
		if(line==13){
			FIO0SET = 0x02000000;   //line 3
			FIO1SET = 0x00080000;   //c
			FIO0SET = 0x10000000;   //line 3
		}	
		if(line==14){
			FIO0SET = 0x02000000;   //line 3
			FIO1SET = 0x00080000;   //c
			FIO0SET = 0x20000000;   //line 3
		}	
		if(line==15){
			FIO0SET = 0x02000000;   //line 3
			FIO1SET = 0x00080000;   //c
			FIO0SET = 0x30000000;   //line 3
		}
		FIO1CLR = 0x00040000;   //oe 0
		FIO1CLR = 0x00020000;   //latch 0
		/////////////////////////////////
		if(part==3){
			if(line<15)
				line++;
			else
				line=0;
		}
		if(part==3){
			if(yline<31)
				yline++;
			else
				yline=0;
		}
		pixel=0;
	}
	
			FIO0CLR = 0x00FF0000;
			FIO0SET = bitplane[part][pixel][yline];
			FIO1SET = 0x00010000;   //clock 1
			FIO1CLR = 0x00010000;   //clock 0

	pixel++;
	//VICIntEnable = (1<<4);
	VICIntEnClr = 0x00000010;
	VICVectAddr = 0x0; // End of interrupt execution
}
void activatepanel(void){
VICIntEnable = (1<<4);
	}
void drawrect(int x1,int x2,int y1,int y2,int r ,int g,int b){
	drawverline(x1,y1,y2,r,g,b);
	drawverline(x2,y1,y2,r,g,b);
	drawhorline(y1,x1,x2,r,g,b);
	drawhorline(y2,x1,x2,r,g,b);
}
void drawverline(int x,int y1,int y2,int r ,int g,int b){
int i;
	for(i=y1;i<=y2;i++)
	drawpixel(x,i,r,g,b);
}
void drawhorline(int y,int x1,int x2,int r,int g,int b){
int i;
	for(i=x1;i<=x2;i++)
	drawpixel(i,y,r,g,b);
}
void drawpixel(int x,int y ,int r ,int g,int b){
setbitplane(x,y ,r ,g,b);
}

void setbitplane(int x,int y ,int r ,int g,int b){
if(y<=15)
	{
	if((r&0x0001)==0x0001)
		bitplane[0][x][y] = bitplane[0][x][y]|0x00040000;
	else
		bitplane[0][x][y] = bitplane[0][x][y]&0xFFFBFFFF;
	if((r&0x0002)==0x0002)
		bitplane[1][x][y] = bitplane[1][x][y]|0x00040000;
	else
		bitplane[1][x][y] = bitplane[1][x][y]&0xFFFBFFFF;
	if((r&0x0004)==0x0004)
		bitplane[2][x][y] = bitplane[2][x][y]|0x00040000;
	else
		bitplane[2][x][y] = bitplane[2][x][y]&0xFFFBFFFF;
	if((r&0x0008)==0x0008)
		bitplane[3][x][y] = bitplane[3][x][y]|0x00040000;
	else
		bitplane[3][x][y] = bitplane[3][x][y]&0xFFFBFFFF;

	if((b&0x0001)==0x0001)
		bitplane[0][x][y] = bitplane[0][x][y]|0x00080000;
	else
		bitplane[0][x][y] = bitplane[0][x][y]&0xFFF7FFFF;
	if((b&0x0002)==0x0002)
		bitplane[1][x][y] = bitplane[1][x][y]|0x00080000;
	else
		bitplane[1][x][y] = bitplane[1][x][y]&0xFFF7FFFF;
	if((b&0x0004)==0x0004)
		bitplane[2][x][y] = bitplane[2][x][y]|0x00080000;
	else
		bitplane[2][x][y] = bitplane[2][x][y]&0xFFF7FFFF;
	if((b&0x0008)==0x0008)
		bitplane[3][x][y] = bitplane[3][x][y]|0x00080000;
	else
		bitplane[3][x][y] = bitplane[3][x][y]&0xFFF7FFFF;

	if((g&0x0001)==0x0001)
		bitplane[0][x][y] = bitplane[0][x][y]|0x00100000;
	else
		bitplane[0][x][y] = bitplane[0][x][y]&0xFFEFFFFF;
	if((g&0x0002)==0x0002)
		bitplane[1][x][y] = bitplane[1][x][y]|0x00100000;
	else
		bitplane[1][x][y] = bitplane[1][x][y]&0xFFEFFFFF;
	if((g&0x0004)==0x0004)
		bitplane[2][x][y] = bitplane[2][x][y]|0x00100000;
	else
		bitplane[2][x][y] = bitplane[2][x][y]&0xFFEFFFFF;
	if((g&0x0008)==0x0008)
		bitplane[3][x][y] = bitplane[3][x][y]|0x00100000;
	else
		bitplane[3][x][y] = bitplane[3][x][y]&0xFFEFFFFF;
	}
	else
	{
	if((r&0x0001)==0x0001)
		bitplane[0][x][y] = bitplane[0][x][y]|0x00200000;
	else
		bitplane[0][x][y] = bitplane[0][x][y]&0xFFDFFFFF;
	if((r&0x0002)==0x0002)
		bitplane[1][x][y] = bitplane[1][x][y]|0x00200000;
	else
		bitplane[1][x][y] = bitplane[1][x][y]&0xFFDFFFFF;
	if((r&0x0004)==0x0004)
		bitplane[2][x][y] = bitplane[2][x][y]|0x00200000;
	else
		bitplane[2][x][y] = bitplane[2][x][y]&0xFFDFFFFF;
	if((r&0x0008)==0x0008)
		bitplane[3][x][y] = bitplane[3][x][y]|0x00200000;
	else
		bitplane[3][x][y] = bitplane[3][x][y]&0xFFDFFFFF;

	if((b&0x0001)==0x0001)
		bitplane[0][x][y] = bitplane[0][x][y]|0x00400000;
	else
		bitplane[0][x][y] = bitplane[0][x][y]&0xFFBFFFFF;
	if((b&0x0002)==0x0002)
		bitplane[1][x][y] = bitplane[1][x][y]|0x00400000;
	else
		bitplane[1][x][y] = bitplane[1][x][y]&0xFFBFFFFF;
	if((b&0x0004)==0x0004)
		bitplane[2][x][y] = bitplane[2][x][y]|0x00400000;
	else
		bitplane[2][x][y] = bitplane[2][x][y]&0xFFBFFFFF;
	if((b&0x0008)==0x0008)
		bitplane[3][x][y] = bitplane[3][x][y]|0x00400000;
	else
		bitplane[3][x][y] = bitplane[3][x][y]&0xFFBFFFFF;

	if((g&0x0001)==0x0001)
		bitplane[0][x][y] = bitplane[0][x][y]|0x00800000;
	else
		bitplane[0][x][y] = bitplane[0][x][y]&0xFF7FFFFF;
	if((g&0x0002)==0x0002)
		bitplane[1][x][y] = bitplane[1][x][y]|0x00800000;
	else
		bitplane[1][x][y] = bitplane[1][x][y]&0xFF7FFFFF;
	if((g&0x0004)==0x0004)
		bitplane[2][x][y] = bitplane[2][x][y]|0x00800000;
	else
		bitplane[2][x][y] = bitplane[2][x][y]&0xFF7FFFFF;
	if((g&0x0008)==0x0008)
		bitplane[3][x][y] = bitplane[3][x][y]|0x00800000;
	else
		bitplane[3][x][y] = bitplane[3][x][y]&0xFF7FFFFF;
	}

}
void drawpixelinit(void){
	int i,j,bp;
	for(j=0; j<32;j++){
	  for(bp=0; bp<4;bp++){
			for(i=0; i<32;i++){
				bitplane[bp][i][j] = 0x00000000;
			}
		}
	}
}
	
void latch(int line){
		FIO1SET = 0x00040000;   //oe 1
		FIO1SET = 0x00020000;   //latch 1
		FIO1CLR = 0x00080000;   //c
		FIO0CLR = 0x32000000;   //CBA__D
		if(line==1)
		{
			FIO0SET = 0x10000000;   //CBA__D
		}
		if(line==2)
		{
			FIO0SET = 0x20000000;   //CBA__D
		}
		if(line==3){
			FIO0SET = 0x30000000;   //line 3
		}	
		if(line==4){
			FIO1SET = 0x00080000;   //c
		}	
		if(line==5){
			FIO1SET = 0x00080000;   //c
			FIO0SET = 0x10000000;   //line 3
		}	
		if(line==6){
			FIO1SET = 0x00080000;   //c
			FIO0SET = 0x20000000;   //line 3
		}	
		if(line==7){
			FIO1SET = 0x00080000;   //c
			FIO0SET = 0x30000000;   //line 3
		}
		if(line==8){
			FIO0SET = 0x02000000;   //line 3
			FIO1CLR = 0x00080000;   //c
			FIO0CLR = 0x30000000;   //line 3
		}
		if(line==9)
		{
			FIO0SET = 0x02000000;   //line 3
			FIO0SET = 0x10000000;   //CBA__D
		}
		if(line==10)
		{
			FIO0SET = 0x02000000;   //line 3
			FIO0SET = 0x20000000;   //CBA__D
		}
		if(line==11){
			FIO0SET = 0x02000000;   //line 3
			FIO0SET = 0x30000000;   //line 3
		}	
		if(line==12){
			FIO0SET = 0x02000000;   //line 3
			FIO1SET = 0x00080000;   //c
		}	
		if(line==13){
			FIO0SET = 0x02000000;   //line 3
			FIO1SET = 0x00080000;   //c
			FIO0SET = 0x10000000;   //line 3
		}	
		if(line==14){
			FIO0SET = 0x02000000;   //line 3
			FIO1SET = 0x00080000;   //c
			FIO0SET = 0x20000000;   //line 3
		}	
		if(line==15){
			FIO0SET = 0x02000000;   //line 3
			FIO1SET = 0x00080000;   //c
			FIO0SET = 0x30000000;   //line 3
		}
		FIO1CLR = 0x00040000;   //oe 0
		FIO1CLR = 0x00020000;   //latch 0
}

void initializepanel(void){
FIO1CLR = 0x02000000;   //buzzer
FIO1CLR = 0x00010000;   //clock 0
FIO1CLR = 0x00020000;   //latch 0
FIO1SET = 0x00040000;   //oe 1
FIO1CLR = 0x00080000;   //c
FIO0CLR = 0x32000000;   //line 0
FIO0CLR = 0x00FF0000;   //rgb 0
drawpixelinit();
}

void GPIO_Init_FAST(void){
//GPIO Fast or Slow Mode bit1-GPIO1, bit0-GPIO0, 0-Slow, 1-Fast
SCS  = 0x03;                                         //Initialise the Fast mode
// Function Select Register TwoBit Comb: 00-GPIO, 01-Function1, 10-Function2, 11-Function3
// P0.0 to P0.15 = PINSEL0(0 to 32) ie P0.0 has PINSEL0.0 and PINSEL0.1 (Two bits for One Pin)
PINSEL0 = 0x00000000;            //P0.0 to P0.15 are GPIO's
PINSEL1 = 0x00000000;                                //P0.16 toP0.31 are GPIO's
//PINSEL2 has only two bits to control PORT1
//Bit 2,  0- Pins P1.26 to P1.36 are GPIO's
//        1- Pins P1.26 to P1.36 are JTAG Debug Port
//Bit 3,  0- Pins P1.16 to P1.25 are GPIO's
//        1- Pins P1.16 to P1.25 are Trace Ports?
PINSEL2 = 0x00000000;     //P1.16 to P1.25 are GPIO's, P1.26 to P1.31 are debug port
FIO1DIR = 0xFFFFFFFF;
FIO0DIR = 0xFFFFFFFF;     //P0 All are Ouput
}


void timerSettings(void){
	initClocks();
	initTimer0();
	T0MR0 = 0X01;
	T0MCR = 0X03;
//T0EMR[0] shows status of MAT0.0
//T0EMR = 0X0030;	//Toggle
//while(T0TC < ms);
//T0TCR = 0x00;
	VICVectAddr4 = (unsigned )timer0ISR; //Pointer Interrupt Function (ISR)
  VICVectCntl4 = (1<<5) | 4; //(bit 5 = 1)->to enable Vectored IRQ slot //bit[4:0]) -> this the source number 
  VICIntEnable = (1<<4); // Enable timer0 interrupt
	T0TCR = 0x02;
	T0TCR = 0x01;
}

void initTimer0(void){
T0CTCR = 0x0;
T0PR = PRESCALE-1;//2 clock cycles @30Mhz
} 

void initClocks(void){
setupPLL0();
feedSeq(); 
connectPLL0(); 
feedSeq();
VPBDIV = 0x01; // PCLK is same as CCLK i.e 60Mhz
}

void setupPLL0(void){
//12Mhz Xtal is connected to LPC2148.
PLL0CON = 0x01;
PLL0CFG = 0x24; //P=1(P=2), M=4(M=5)
}

void feedSeq(void){
PLL0FEED = 0xAA;
PLL0FEED = 0x55;
}

void connectPLL0(void){
while( !( PLL0STAT & PLOCK ));
PLL0CON = 0x03;
}